# Ogre::GpuProgramPtr Class Reference
Resources

Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr. More...

`#include <OgreGpuProgram.h>`

Inheritance diagram for Ogre::GpuProgramPtr:
[legend]

List of all members.

## Public Member Functions

| GpuProgramPtr ()
| GpuProgramPtr (GpuProgram *rep)
| GpuProgramPtr (const GpuProgramPtr &r)
| GpuProgramPtr (const ResourcePtr &r)
GpuProgramPtr & | operator= (const ResourcePtr &r)
| Operator used to convert a ResourcePtr to a GpuProgramPtr.
GpuProgramPtr & | operator= (const HighLevelGpuProgramPtr &r)
| Operator used to convert a HighLevelGpuProgramPtr to a GpuProgramPtr.
GpuProgram & | operator* () const
GpuProgram * | operator-> () const
GpuProgram * | get () const
void | bind (GpuProgram *rep, SharedPtrFreeMethod inFreeMethod=SPFM_DELETE)
| Binds rep to the SharedPtr.
bool | unique () const
unsigned int | useCount () const
unsigned int * | useCountPointer () const
GpuProgram * | getPointer () const
SharedPtrFreeMethod | freeMethod () const
bool | isNull (void) const
void | setNull (void)

## Protected Member Functions

void | release (void)
virtual void | destroy (void)
virtual void | swap (SharedPtr< GpuProgram > &other)

## Protected Attributes

GpuProgram * | pRep
unsigned int * | pUseCount
SharedPtrFreeMethod | useFreeMethod

## Detailed Description

Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.

Note:
  Has to be a subclass since we need operator=. We could templatise this instead of repeating per Resource subclass, except to do so requires a form VC6 does not support i.e. ResourceSubclassPtr<T> : public SharedPtr<T>

Definition at line 432 of file OgreGpuProgram.h.

## Constructor & Destructor Documentation

Ogre::GpuProgramPtr::GpuProgramPtr | ( |  | ) |

Definition at line 435 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | GpuProgram * | rep | ) | `[explicit]`

Definition at line 436 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | const GpuProgramPtr & | r | ) |

Definition at line 437 of file OgreGpuProgram.h.

Ogre::GpuProgramPtr::GpuProgramPtr | ( | const ResourcePtr & | r | ) |

Definition at line 438 of file OgreGpuProgram.h.

References Ogre::SharedPtr< T >::getPointer(), OGRE_COPY_AUTO_SHARED_MUTEX, OGRE_LOCK_MUTEX, OGRE_MUTEX_CONDITIONAL, and Ogre::SharedPtr< T >::useCountPointer().

## Member Function Documentation

void Ogre::SharedPtr< GpuProgram >::bind | ( | GpuProgram * | rep,
|  | SharedPtrFreeMethod | inFreeMethod = `SPFM_DELETE`
| ) |  | `[inherited]`

Binds rep to the SharedPtr.

Remarks:
  Assumes that the SharedPtr is uninitialised!

Definition at line 167 of file OgreSharedPtr.h.

virtual void Ogre::SharedPtr< GpuProgram >::destroy | ( | void |  | ) | `[protected, virtual, inherited]`

Definition at line 223 of file OgreSharedPtr.h.

SharedPtrFreeMethod Ogre::SharedPtr< GpuProgram >::freeMethod | ( |  | ) | const`[inherited]`

Definition at line 181 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::get | ( | void |  | ) | const`[inherited]`

Definition at line 161 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::getPointer | ( |  | ) | const`[inherited]`

Definition at line 180 of file OgreSharedPtr.h.

bool Ogre::SharedPtr< GpuProgram >::isNull | ( | void |  | ) | const`[inherited]`

Definition at line 183 of file OgreSharedPtr.h.

GpuProgram & Ogre::SharedPtr< GpuProgram >::operator* | ( |  | ) | const`[inherited]`

Definition at line 159 of file OgreSharedPtr.h.

GpuProgram * Ogre::SharedPtr< GpuProgram >::operator-> | ( |  | ) | const`[inherited]`

Definition at line 160 of file OgreSharedPtr.h.

GpuProgramPtr& Ogre::GpuProgramPtr::operator= | ( | const HighLevelGpuProgramPtr & | r | ) |

Operator used to convert a HighLevelGpuProgramPtr to a GpuProgramPtr.

GpuProgramPtr& Ogre::GpuProgramPtr::operator= | ( | const ResourcePtr & | r | ) |

Operator used to convert a ResourcePtr to a GpuProgramPtr.

Definition at line 455 of file OgreGpuProgram.h.

References Ogre::SharedPtr< T >::getPointer(), Ogre::SharedPtr< T >::isNull(), OGRE_COPY_AUTO_SHARED_MUTEX, OGRE_LOCK_MUTEX, OGRE_MUTEX_CONDITIONAL, and Ogre::SharedPtr< T >::useCountPointer().

void Ogre::SharedPtr< GpuProgram >::release | ( | void |  | ) | `[protected, inherited]`

Definition at line 197 of file OgreSharedPtr.h.

void Ogre::SharedPtr< GpuProgram >::setNull | ( | void |  | ) | `[inherited]`

Definition at line 185 of file OgreSharedPtr.h.

virtual void Ogre::SharedPtr< GpuProgram >::swap | ( | SharedPtr< GpuProgram > & | other | ) | `[protected, virtual, inherited]`

Definition at line 247 of file OgreSharedPtr.h.

bool Ogre::SharedPtr< GpuProgram >::unique | ( |  | ) | const`[inherited]`

Definition at line 176 of file OgreSharedPtr.h.

unsigned int Ogre::SharedPtr< GpuProgram >::useCount | ( |  | ) | const`[inherited]`

Definition at line 177 of file OgreSharedPtr.h.

unsigned int* Ogre::SharedPtr< GpuProgram >::useCountPointer | ( |  | ) | const`[inherited]`

Definition at line 178 of file OgreSharedPtr.h.

## Member Data Documentation

GpuProgram * Ogre::SharedPtr< GpuProgram >::pRep`[protected, inherited]`

Definition at line 63 of file OgreSharedPtr.h.

unsigned int* Ogre::SharedPtr< GpuProgram >::pUseCount`[protected, inherited]`

Definition at line 64 of file OgreSharedPtr.h.

SharedPtrFreeMethod Ogre::SharedPtr< GpuProgram >::useFreeMethod`[protected, inherited]`

Definition at line 65 of file OgreSharedPtr.h.

The documentation for this class was generated from the following file:

- OgreGpuProgram.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun May 8 2011 20:28:11